#pragma hdrstop

//---------------------------------------------------------------------------
//#pragma argsused
#pragma comment(lib,"ws2_32.lib")
#include <stdio.h>
#include <memory.h>
#include <winsock2.h>
#include <iostream>
#include<iomanip> // for setfill setw

using namespace std;

#define RECV_POSTED 1001
#define SEND_POSTED 1002

int Init();

typedef struct _PER_HANDLE_DATA
{
	SOCKET sock;
}PER_HANDLE_DATA,* LPPER_HANDLE_DATA;

typedef struct _PER_IO_OPERATION_DATA
{
	OVERLAPPED Overlapped;
	WSABUF DataBuff;
	char Buff[24];
	BOOL OperationType;
}PER_IO_OPERATION_DATA,* LPPER_IO_OPERATION_DATA;

DWORD WINAPI ServerWorkerThread(LPVOID CompletionPort);

int main(int argc, char* argv[])
{
	LPPER_HANDLE_DATA perHandleData;
	LPPER_IO_OPERATION_DATA ioperdata;
	SYSTEM_INFO siSys;
	SOCKET sockListen;
	struct sockaddr_in addrLocal;
	//char buf[24];
	int nRet = 0;
	DWORD nThreadID;
	SOCKET sockAccept;
	DWORD dwFlags = 0;
	DWORD dwRecvBytes;
	int nReuseAddr = 1;

	cout<<"ʼ..."<<endl;
	if(Init() != 0)
		goto theend;

	//һIOɶ˿
	cout<<"һIOɶ˿"<<endl;
	HANDLE hCompletionPort;
	hCompletionPort = CreateIoCompletionPort(INVALID_HANDLE_VALUE,NULL,0,0);
	if(hCompletionPort == INVALID_HANDLE_VALUE)
	{
		cout<<"IOɶ˿ʧ"<<endl;
		goto theend;
	}
	//ȡCPUĿ
	GetSystemInfo(&siSys);
	cout<<"CPUĺΪ:"<<siSys.dwNumberOfProcessors<<endl;
	//һĿḶ́߳һһ̴߳
	for(int i = 1;i<=(int)siSys.dwNumberOfProcessors*2;i++)//NumberOfProcessors
	{
		HANDLE hThread;
		hThread = CreateThread(NULL,0,ServerWorkerThread,(LPVOID)hCompletionPort,0,&nThreadID);
		cout<<"߳"<<i<<endl;
		CloseHandle(hThread);
	}
	//SOCKET
	cout<<"SOCKET"<<endl;
	sockListen = WSASocket(AF_INET,SOCK_STREAM,0,NULL,0,WSA_FLAG_OVERLAPPED);
	if(sockListen == SOCKET_ERROR)
	{
		cout<<"WSASocket"<<endl;
		goto theend;
	}
	//socket˿Ϊ
	if(setsockopt(sockListen,SOL_SOCKET,SO_REUSEADDR,(const char *)&nReuseAddr,sizeof(int)) != 0)
	{
		cout<<"setsockopt"<<endl;
		goto theend;
	}
	addrLocal.sin_family = AF_INET;
	addrLocal.sin_addr.s_addr = htonl(INADDR_ANY);
	addrLocal.sin_port = htons(9090);
	if(bind(sockListen,(struct sockaddr *)&addrLocal,sizeof(sockaddr_in)) != 0)
	{
		cout<<"bind"<<endl;
		int n = WSAGetLastError();
		goto theend;
	}
	//׼
	if(listen(sockListen,5)!=0)
	{
		cout<<"listen"<<endl;
		goto theend;
	}
	cout<<"Socket Listen ..."<<endl;
	while(true)
	{
		//ûӣɶ˿ڹ
		sockAccept = WSAAccept(sockListen,NULL,NULL,NULL,0);
		perHandleData = (LPPER_HANDLE_DATA)malloc(sizeof(PER_HANDLE_DATA));
		if(perHandleData == NULL)
			continue;
		cout<<"Accept:socket number "<<sockAccept<<""<<endl;
		perHandleData->sock = sockAccept;

		ioperdata = (LPPER_IO_OPERATION_DATA)malloc(sizeof(PER_IO_OPERATION_DATA));
		memset(&(ioperdata->Overlapped),0,sizeof(OVERLAPPED));
		ioperdata->DataBuff.len = 24;
		ioperdata->DataBuff.buf = ioperdata->Buff;
		ioperdata->OperationType = RECV_POSTED;
		if( ioperdata == NULL)
		{
			free(perHandleData);
			continue;
		}
		//
		//cout<<"SOCKETɶ˿..."<<endl;
		if(CreateIoCompletionPort((HANDLE)sockAccept,hCompletionPort,(DWORD)perHandleData,0) == NULL)
		{
			cout<<sockAccept<<"createiocompletionport"<<endl;
			free(perHandleData);
			free(ioperdata);
			continue;
		}
		////Ͷݽղ ,  ޷.
		////cout<<"Ͷݽղ"<<endl;
		if (SOCKET_ERROR == WSARecv(sockAccept,&(ioperdata->DataBuff),1,&dwRecvBytes,&dwFlags,&(ioperdata->Overlapped),NULL))
		{
			cout << "WSARecv ERROR:" << WSAGetLastError() << endl;
		}
	}
theend:
	getchar();
	return 0;
}
//---------------------------------------------------------------------------
int Init()
{
	WSAData wsaData;
	if(WSAStartup(MAKEWORD(2,2),&wsaData) != 0)
	{
		cout<<"WSAStartupʧ"<<endl;
		return -1;
	}

	if(LOBYTE(wsaData.wVersion) != 2 || HIBYTE(wsaData.wVersion) != 2)
	{
		cout<<"SOCKET汾"<<endl;
		WSACleanup();
		return -1;
	}
	return 0;
}

DWORD WINAPI ServerWorkerThread(LPVOID CompletionPort)
{
	HANDLE ComPort = (HANDLE)CompletionPort;
	DWORD BytesTransferred;
	//LPOVERLAPPED Overlapped;
	LPPER_HANDLE_DATA PerHandleData;
	LPPER_IO_OPERATION_DATA PerIoData;
	DWORD SendBytes,RecvBytes;
	DWORD Flags = 0;
	BOOL bT;

	while(TRUE)
	{
		//ȴɶ˿SOCKET
		cout<<"["<<GetCurrentProcessId()<<":"<<GetCurrentThreadId()<<"]"<<":ȴɶ˿SOCKET"<<endl;
		bT = GetQueuedCompletionStatus(ComPort,
			&BytesTransferred,(LPDWORD)&PerHandleData,
			(LPOVERLAPPED *)&PerIoData,INFINITE);

		//Ƿд
		if(BytesTransferred == 0 &&
			(PerIoData->OperationType == RECV_POSTED ||
			PerIoData->OperationType == SEND_POSTED))
		{
			//رSOCKET
			cout<<"["<<GetCurrentProcessId()<<":"<<GetCurrentThreadId()<<"]"<<PerHandleData->sock<<"SOCKETر"<<endl;
			closesocket(PerHandleData->sock);
			free(PerHandleData);
			free(PerIoData);
			continue;
		}

		//socket,ʱ,ô...ҪôŻ,תƵطȥ.ҪôIOCP.
		//Sleep(1000);

		//Ϊ
		if(PerIoData->OperationType == RECV_POSTED)
		{
			//
			cout<<"["<<GetCurrentProcessId()<<":"<<GetCurrentThreadId()<<"]"<<"մ"<<endl;
			cout<<"["<<GetCurrentProcessId()<<":"<<GetCurrentThreadId()<<"]"<<PerHandleData->sock<<" SOCKET :"<<PerIoData->Buff<<endl;
			//Ӧͻ
			ZeroMemory(PerIoData->Buff,24);
			//#define _CRT_SECURE_NO_WARNINGS 1
			//strcpy(PerIoData->Buff,"OK");
			strcpy_s(PerIoData->Buff,"OK");
			Flags = 0;
			ZeroMemory((LPVOID)&(PerIoData->Overlapped),sizeof(OVERLAPPED));
			PerIoData->DataBuff.len = 2;
			PerIoData->DataBuff.buf = PerIoData->Buff;
			PerIoData->OperationType = SEND_POSTED;
			WSASend(PerHandleData->sock,&(PerIoData->DataBuff),
				1,&SendBytes,0,&(PerIoData->Overlapped),NULL);
		}
		else //if(PerIoData->OperationType == SEND_POSTED)
		{
			//ʱĴ
			cout<<"["<<GetCurrentProcessId()<<":"<<setfill('0')<<setw(4)<<GetCurrentThreadId()<<"]"<<"ʹ"<<endl;
			Flags = 0;
			ZeroMemory((LPVOID)&(PerIoData->Overlapped),sizeof(OVERLAPPED));
			ZeroMemory(PerIoData->Buff,24);
			PerIoData->DataBuff.len = 24;
			PerIoData->DataBuff.buf = PerIoData->Buff;
			PerIoData->OperationType = RECV_POSTED;
			WSARecv(PerHandleData->sock,&(PerIoData->DataBuff),
				1,&RecvBytes,&Flags,&(PerIoData->Overlapped),NULL);
		}
	}
}